Subject: Re: [RFC PATCH] udp: allow busy_poll on some unconnected sockets

From: Jonathan Cooper <[email-masked]>
Date: Fri, 11 Apr 2014 11:44:07 +0100

On 10/04/14 20:04, Eric Dumazet wrote:
> On Thu, 2014-04-10 at 19:38 +0100, Edward Cree wrote:
>> On 10/04/14 19:32, Eric Dumazet wrote:
>>> On Thu, 2014-04-10 at 19:04 +0100, Edward Cree wrote:
>>>
>>>> Tested by setting IFF_SINGLE_NAPI in sfc; a UDP ping-pong test showed a
>>>>   performance benefit from sysctl net.core.busy_{read,poll}=50 in both the
>>>>   connected and unconnected case, where previously it only saw the benefit
>>>>   when the socket had been connected.
>>> Right, but how often do we have single NAPI devices on hosts wanting
>>> very low latencies ?
>>>
>> Well, sfc only has a single NAPI context per device, and I'm fairly sure
>> most sfc users want very low latencies.
>> Or have I misunderstood?
> sfc is multi queue/channel, but has a single NAPI instance ?
>
> Sounds wierd.
>
> Please explain me, how GRO can be efficient.
>
> I believe you have one napi per channel.
>
Whoops, this is my fault, I derped reading our NAPI code. You are 
entirely correct, we do have multiple NAPI instances per device, so our 
proposed scheme is unworkable. We'll just have to connect the socket.
Sorry to waste your time.

Jon